\ProvidesPackage{hrfmath}[2020/04/19 Math setup, should be loaded after hrfgerman]

% for options
\RequirePackage{etoolbox}
\RequirePackage{pgfopts}
% package options
% theorem numbering style
\newtoggle{numberindividually}
\newtoggle{nomasternumbers}
\newtoggle{numberwithin}
\newtoggle{empheqoverload}{}
\pgfkeys{
        /hrftex/hrfmath/.cd,
            numberindividually/.is choice,
            numberindividually/true/.code=\toggletrue{numberindividually},
            numberindividually/false/.code=\togglefalse{numberindividually},
            numberindividually/.initial=false,
            numberindividually/.default=true,
            nomasternumbers/.is choice,
            nomasternumbers/true/.code=\toggletrue{nomasternumbers},
            nomasternumbers/false/.code=\togglefalse{nomasternumbers},
            nomasternumbers/.initial=false,
            nomasternumbers/.default=true,
            empheqoverload/true/.code=\toggletrue{empheqoverload},
            empheqoverload/false/.code=\togglefalse{empheqoverload},
            empheqoverload/.initial=false,
            empheqoverload/.default=true,
            numberwithin/.value required,
            numberwithin/.initial,
}
% 


\ProcessPgfOptions{/hrftex/hrfmath}

% Process numberwithin
\pgfkeys{/hrftex/hrfmath/numberwithin/.get=\numbertheoremswithinthis}
\def\novaluegiven{\pgfkeysnovalue}
\ifdefequal{\numbertheoremswithinthis}{\novaluegiven}{\togglefalse{numberwithin}}{\toggletrue{numberwithin}}

% this will already be loaded if used from hrftex
\RequirePackage[utf8]{inputenc}
\RequirePackage[T1]{fontenc}

% Fix problems with too many math fonts
\newcommand\hmmax{0}
\newcommand\bmmax{0}

% main math package
\RequirePackage{mathtools}

%more symbols
\RequirePackage{mathrsfs}

% physics package
\RequirePackage{physics}

% better \left, \right spacing
\RequirePackage{mleftright}
\mleftright % redefine \left to \mleft and \right to \mright

% better boxed equations, better endtheoremmark placement
\iftoggle{empheqoverload}{\PassOptionsToPackage{overload}{empheq}}{}
\PassOptionsToPackage{ntheorem}{empheq}
\RequirePackage{empheq}

% Possibility to change between left and right equation numbers
\newcommand{\leqnomode}{\tagsleft@true}
\newcommand{\reqnomode}{\tagsleft@false}

\RequirePackage{amssymb}
\RequirePackage{amstext}

% for \mathds{1}
\RequirePackage{dsfont}

% for some symbols (documented when used)
\RequirePackage{stmaryrd}

% for theorems
\PassOptionsToPackage{amsmath, thmmarks, amsthm}{ntheorem}
\RequirePackage{ntheorem}
\usetagform{default}
\renewcommand{\qedsymbol}{$\blacksquare$} % so that the square can be used for subproofs
\newenvironment{subproof}[1][{}]{\ifthenelse{\equal{#1}{}}{\begin{proof}}{\begin{proof}[{#1}]}\renewcommand{\qedsymbol}{$\square$}}{\end{proof}}


\def\DeclareMathOperatorWithDelimiter#1#2[#3,#4]#5#6#7#8{ 
  \newcommand{#2}{}
  \WithSuffix\DeclarePairedDelimiterXPP#2+[#3]{#5}{#6}{#7}{}{#8} %  #2+ with delimiters, #2+*: auto scales, #2+[<size-command>] sets delimiters to size
  \WithSuffix\newcommand#2-[#3]{#5 #8} % #1-:no delimiters
  \WithSuffix\newcommand#2;[\ifstrempty{#4}{\the\numexpr #3-1\relax}{#4}]{#5} % #2;: (with #2-1 arguments) only prints #4
  \expandafter\let\csname  \NoSuffixName#2\expandafter\endcsname\csname\SuffixName#2#1\endcsname
}
\def\DeclareFunction#1#2[#3,#4]#5#6{
    \DeclareMathOperatorWithDelimiter#1{#2}[#3,#4]{#5}{\lparen}{\rparen}{#6}
}
\def\DeclareMathPostOperatorWithDelimiter#1#2[#3]#4#5#6#7{
    \newcommand{#2}{}
    \WithSuffix\DeclarePairedDelimiterXPP#2+[#3]{}{#5}{#6}{#4}{#7} %  #2+ variant, #2+*: auto scales, #2+[<size-command>] sets delimiters to size
    \WithSuffix\newcommand#2-[#3]{{#7}#4} % #1-: no delimiters
    \expandafter\let\csname  \NoSuffixName#2\expandafter\endcsname\csname\SuffixName#2#1\endcsname
}

\def\DeclarePostFunction#1#2[#3]#4#5{
    \DeclareMathPostOperatorWithDelimiter#1{#2}[#3]{#4}{\lparen}{\rparen}{#5}
}


% Note: if you want to swap the default after definition, or otherwise redefine a MOWD or MPOWD macro, first define a new MOWD or MPOWD macro with a new name and then \let it to the old macro name.

\theoremstyle{definition}
% consistent numbering
\iftoggle{numberwithin}{\newtheorem{generalthm}{}[\numbertheoremswithinthis]}{\newtheorem{generalthm}{}}
\renewtheorem*{generalthm*}{}

% for references to items in enumerations
\setlist[enumerate,1]{label=\rechtsklammer{\roman*}, ref=\iftoggle{numberindividually}{}{\thegeneralthm.}\rechtsklammer{\roman*}}
\newlist{eigenschaftenenumerate}{enumerate}{3}
\setlist[eigenschaftenenumerate]{label=\rechtsklammer{\alph*}, ref=\iftoggle{numberindividually}{}{\thegeneralthm.}\rechtsklammer{\alph*}}
\newlist{eigenschaftendescription}{description}{3}
\setlist[eigenschaftendescription]{font=\normalfont}
\newlist{proofenumerate}{enumerate}{3}
\setlist[proofenumerate]{label=\arabic*., wide}
\newlist{proofdescription}{description}{3}
\setlist[proofdescription]{font=\bfseries, wide}
% for references to description items
\def\namedlabel#1#2{\begingroup
    #2%
    \def\@currentlabel{#2}%
    \phantomsection\label{#1}\endgroup
}

\newcommand{\NewTheorem}[2]{
    % \newaliascnt{#1}{theorem}    
    \iftoggle{numberindividually}
        {\iftoggle{numberwithin}
            {\newtheorem{#1}{#2}[\numbertheoremswithinthis]}
            {\newtheorem{#1}{#2}}}
        {\newtheorem{#1}[generalthm]{#2}} 
    \renewtheorem*{#1*}{#2}
    \iftoggle{nomasternumbers}{\expandafter\renewcommand\csname the#1\endcsname{\arabic{#1}}}{}
}

\theoremheaderfont{\normalfont\bfseries}


\NewTheorem{attention}{\emph{Attention}}
\NewTheorem{convention}{Convention}
\NewTheorem{consider}{Consider}
\NewTheorem{example}{Example}
\NewTheorem{counterexample}{Counterexample}
\NewTheorem{claim}{Claim}
\NewTheorem{remark}{Remark}
\NewTheorem{remarks}{Remarks}
\NewTheorem{definition}{Definition}
\NewTheorem{definitions}{Definitions}
\NewTheorem{reminder}{Reminder}
\NewTheorem{fact}{Fact}
\NewTheorem{facts}{Facts}
\NewTheorem{question}{Question}
\NewTheorem{idea}{Idea}
\NewTheorem{lemma}{Lemma}
\NewTheorem{deflemma}{Definition / Lemma}
\NewTheorem{corollary}{Corollary}
\NewTheorem{notation}{Notation}
\NewTheorem{motivation}{Motivation}
\NewTheorem{proposition}{Proposition}
\NewTheorem{propositiondef}{Proposition / Definition}
\NewTheorem{theorem}{Theorem}
\NewTheorem{theoremdef}{Theorem / Definition}
\NewTheorem{target}{Target}
\NewTheorem{basic_constructions}{Basic Constructions}
\NewTheorem{observe}{Observe}
\NewTheorem{remarkdef}{Remark / Definition}
\NewTheorem{defremark}{Definition / Remark}
\NewTheorem{note}{Note}
\NewTheorem{careful}{Careful}
\NewTheorem{exercise}{Exercise}
\NewTheorem{notations/conventions}{Notations / Conventions}
\NewTheorem{notation/remark}{Notation / Remark}



\newtheorem{subtheorem}{Theorem}[generalthm]
\renewcommand{\thesubtheorem}{\thegeneralthm.\arabic{subtheorem}}

\theoremseparator{.}
\theorembodyfont{\normalfont}
\newtheoremstyle{blank}%
{\item[\theorem@headerfont\hskip\labelsep ##1\theorem@separator]}%
{\item[\theorem@headerfont \hskip\labelsep\relax ##2\ ##3\theorem@separator]}
\newtheoremstyle{nonumberblank}{\item[]}%
{\item[\theorem@headerfont \hskip\labelsep\relax ##3\theorem@separator]}
\theoremstyle{blank}
\newtheorem{blank}[generalthm]{}
\renewtheorem*{blank*}{}

% stack below with optional argument
\RequirePackage{stackrel}

% left and right sub- and superscripts
\RequirePackage{leftidx}

% braket and (right now more importantly) proper set notation
% \RequirePackage{braket}

% for composed symbols including a colon
\RequirePackage{colonequals}


% tikz with most important libraries
\RequirePackage{tikz}
\usetikzlibrary{matrix, arrows, cd, patterns, babel, calc, math, external}
\RequirePackage{tkz-euclide}

\newcommand*\circled[1]{
    \tikz[baseline=(char.base)]{
        \node[shape=circle, draw, inner sep=2pt] (char) {#1};
    }
}

% \tikzexternalize

\RequirePackage{cancel}

% Bold math
\RequirePackage{bm}

% Easily typeset systems of equations (French package)
\RequirePackage{systeme}


% Roman numerals
\RequirePackage{romannum}

% Nice Matrices and Arrays
\RequirePackage{nicematrix}

% Large Matrices
\setcounter{MaxMatrixCols}{20}

% Units
\RequirePackage{siunitx}

% Add \contra symbol to denote contradiction
\RequirePackage{stmaryrd} % for \lightning
\newcommand\contra{\scalebox{1.5}{$\lightning$}}

\definecolor{correct}{HTML}{009900}
\newcommand\correct[2]{\ensuremath{\:}{\color{red}{#1}}\ensuremath{\to }{\color{correct}{#2}}\ensuremath{\:}}
\newcommand\green[1]{{\color{correct}{#1}}}


% \RequirePackage{cool} % kind of bad package
% \Style{ArcTrig=arc, Conjugate=overline}

\RequirePackage{derivative}

%better arrows
\RequirePackage{extarrows}

% Better vector arrows
\RequirePackage{esvect}

% Intervals
\RequirePackage{interval}
\intervalconfig{
    soft open fences,
    scaled
}

% end of package imports


% allow a page break within amsmath math formulas,
% use \\* to prohibit a page break
\allowdisplaybreaks[1]

% possibility to save styles
\def\@mstyleD{\displaystyle}
\def\@mstyleT{\textstyle}
\def\@mstyleS{\scriptstyle}
\def\@mstyles{\scriptscriptstyle}
%
\def\SavedStyle{\csname @mstyle\m@switch\endcsname}
%
\newcommand\ThisStyle[1]{%
  \ifmmode%
    \def\@mmode{T}\mathchoice%
      {\edef\m@switch{D}#1}%
      {\edef\m@switch{T}#1}%
      {\edef\m@switch{S}#1}%
      {\edef\m@switch{s}#1}%
  \else%
    \def\@mmode{F}%
    \edef\m@switch{T}#1%
  \fi%
}


% possibility to ignore height and apply later (with SavedHeight)
\newsavebox{\mastercontent}
\newsavebox{\slavecontent}
\newsavebox{\masterheight}
\newsavebox{\slaveheight}
\newsavebox{\masterwidth}
\newsavebox{\slavewidth}
\newsavebox{\compositeheight}
\newsavebox{\compositewidth}


% provides \slavecontent and \mastercontent to access content, \slaveheight and \masterheight to access height, \slavewidth and \masterwidth to access width
\newcommand\heightcontext[2]{\sbox{\slavecontent}{\( #1 \)}\sbox{\mastercontent}{\(#2\)}\sbox{\slaveheight}{\vphantom{\usebox{\slavecontent}}}\sbox{\masterheight}{\vphantom{\usebox{\mastercontent}}}\sbox{\slavewidth}{\hphantom{\usebox{\slavecontent}}}\sbox{\masterwidth}{\hphantom{\usebox{\mastercontent}}}}


% number this specific equation
\newcommand{\numberthis}{\addtocounter{equation}{1}\tag{\theequation}}


% phantom relations for better alignment
\newcommand{\rphantom}[1]{\mathrel{\phantom{#1}}}


% vertical variants of relations
\newcommand{\vertrelation}[1]{\protect\rotatebox{90}{\(\scriptstyle#1\)}}
\newcommand{\vertlt}{\vertrelation{<}}
\newcommand{\vertleq}{\vertrelation{\leq}}
\newcommand{\vertgt}{\vertrelation{>}}
\newcommand{\vertgeq}{\vertrelation{\geq}}
\newcommand{\vertne}{\vertrelation{\ne}}
\newcommand{\vertin}{\vertrelation{\in}}
\newcommand{\vertni}{\vertrelation{\ni}}

% first (optional) argument - size, then explanation, then whats to be explained
% should be used in math mode
\newcommand{\equalto}[3][]{\underset{\scriptstyle\overset{\mkern4mu\scalebox{1}[0.7]{\verteq[#1]}}{\mathclap{#2}}}{#3}}
% accepts vertical relation as first necessary (can be made with vertrelation)
\newcommand{\underrelate}[4][]{\underset{\overset{\csname #1\endcsname{#2}}{\mathclap{#3}}}{#4}}
\newcommand{\overrelate}[4][]{\overset{\underset{\csname #1\endcsname{#2}}{\mathclap{#3}}}{#4}}
\newcommand{\explain}[3][]{\underrelate[#1]{\uparrow}{#2}{#3}}

\newcommand{\braceannotate}[2]{\ThisStyle{\underbrace{\SavedStyle #2}_{#1}}}

% adjustable size
\newcommand{\verteq}[1][]{\protect\raisebox{2pt}{\scalebox{1}[0.7]{\(\csname #1\endcsname{\Vert}\)}}}

% for use over relations
\newcommand{\needed}[1]{\overset{!}{#1}}
\newcommand{\isittrue}[1]{\overset{?}{#1}}

\newcaptionname{english}{\zuzeigentext}{To be shown: }
\newcaptionname{ngerman}{\zuzeigentext}{$\mathrm{Z\kern-.55em\raise-0.5ex\hbox{Z}}$ }

% can be used in both math and text mode
\newcommand{\zuzeigen}[1]{\par\doublebox{%
\begin{minipage}{\the\dimexpr \textwidth - 13.6pt\relax}\zuzeigentext #1\end{minipage}}}
\newcommand{\zuzeigenmath}[1]{\par\doublebox{%
\begin{minipage}{\the\dimexpr\textwidth-\mathindent-13.6pt\relax}\zuzeigentext #1\end{minipage}}}
\let\tobeshown\zuzeigen
\let\tobeshownmath\zuzeigenmath

% verbose definitions
\newcommand*{\defines}{\eqqcolon}
\newcommand*{\definedas}{\coloneqq}
\newcommand*{\definedequivalentto}{\vcentcolon\Leftrightarrow}
\newcommand*{\maps}{\colon}

% for equivalence proofs
\RequirePackage{csquotes}
\newcommand*{\hin}{{\enquote{\( \implies \)}}}
\newcommand*{\rueck}{\enquote{\( \impliedby \)}}
\newcommand*{\hinrueck}{\enquote{\( \iff \)}}
\newcommand*{\sethin}{{\enquote{\( \subset \)}}}
\newcommand*{\setrueck}{{\enquote{\( \supset \)}}}


% equation sign with sim sign over it
\DeclareRobustCommand{\simeqq}{\cong}

% Better logic spacing
\newcommand*{\logicspace}{\hspace{0.5em}}

% Make quantifiers operators
\let\oldexists\exists
\let\exists\relax
\DeclareMathOperator{\exists}{\ \oldexists}

\let\oldnexists\nexists
\let\nexists\relax
\DeclareMathOperator{\nexists}{\ \oldnexists}

\let\oldforall\forall
\let\forall\relax
\DeclareMathOperator{\forall}{\ \oldforall}

% to avoid warnings about "!"
\DeclareMathOperator{\existsone}{\ \exists!}

\DeclareFunction+{\anzahl}[1,]{\#}{#1}

% add \ndivides as does not divide
\newcommand*{\divides}{\mid}
\newcommand*{\ndivides}{\nmid}

% Add angled v as \varv
\DeclareSymbolFont{matha}{OML}{txmi}{m}{it} % txfonts
\DeclareMathSymbol{\varv}{\mathord}{matha}{118}


% overline replacement
\newcommand{\widebar}[1]{\mathop{\overline{#1}}}

% 


% Replace leq and req signs
% \let\leqold=\leq
% \let\leqqold=\leqq
% \let\geqold=\geq
% \let\geqqold=\geqq
% \let\triaglelefteqold=\trianglelefteq
% \let\triaglerighteqold=\trianglerighteq
% \renewcommand*{\leq}{\leqslant}
% \renewcommand*{\leqq}{\leqqslant}
% \renewcommand*{\geq}{\geqslant}
% \renewcommand*{\geqq}{\geqqslant}
% \renewcommand*{\trianglelefteq}{\trianglelefteqslant}
% \renewcommand*{\trianglerighteq}{\trianglerighteqslant}
\newcommand*{\propersubgroup}{\le}
\newcommand{\normalsubgroup}{\trianglelefteq}
\newcommand{\propernormalsubgroup}{\triangleleft}
\newcommand*{\propersupgroup}{\ge}
\newcommand*{\subgroup}{\leqold}
\newcommand*{\supgroup}{\geqold}
\newcommand*{\subspace}{\leqold}
\newcommand*{\supspace}{\geqold}

% easier long to
\newcommand*{\longto}{\longrightarrow}

% verbose limits
\newcommand*{\goesto}{\to}
\newcommand*{\goesupto}{\nearrow}
\newcommand*{\goesdownto}{\searrow}
\newcommand*{\weakto}{\rightharpoonup}
\DeclareMathOperator*{\weaklim}{w-lim}
\DeclareMathOperator*{\stronglim}{s-lim}

% \newcommand*{\differential}{\mathop{}\!d}
\newcommand*{\improperdifferential}[1]{d#1\,}
\DeclareFunction-{\directionalderivative}[2,]{\partial_{#1}}{#2}
\DeclareFunction-{\totalderivative}[1,]{D}{#1}

% For complex
% \DeclareFunction-{\real}[1,]{\mathrm{Re}}{#1}
% \DeclareFunction-{\imaginary}[1,]{\mathrm{Im}}{#1}
\newcommand{\conjugate}[1]{\widebar{#1}\nolimits}

% sets
\newcommand*{\set}[1]{
    \@ifnextchar\bgroup{\set@double{#1}}{\set@single{#1}}%
}
\newcommand{\set@double}[2]{\left\{ #1 \middle| #2 \right\}}
\newcommand{\set@single}[1]{\left\{ #1 \right\}}

% Prettier emptyset
% \renewcommand{\emptyset}{\varnothing}

\newcommand*{\zeroset}{{\set{0}}}
\newcommand*{\minuszero}{{\setminus\zeroset}}
\newcommand*{\Minuszero}{{\!\setminus\!\zeroset}}
\DeclarePairedDelimiterXPP{\powerset}[1]{\mathbb{P}}{\lparen}{\rparen}{}{#1}


% min and max with delimiters
\let\min\relax
\DeclareMathOperator{\min}{min}
\let\Min\relax
\DeclareFunction+{\Min}[1,]{\min}{#1}
\let\max\relax
\DeclareMathOperator{\max}{max}
\let\Max\relax
\DeclareFunction+{\Max}[1,]{\max}{#1}
\DeclareFunction+{\Med}[3,0]{\operatorname{med}}{#1,#2,#3}

% make trigonometric functions operators with delimiters
\let\Sin\relax
\DeclareFunction-{\Sin}[1,]{\sin}{#1}
\let\Cos\relax
\DeclareFunction-{\Cos}[1,]{\cos}{#1}
\let\Tan\relax
\DeclareFunction-{\Tan}[1,]{\tan}{#1}
\let\Sec\relax
\DeclareFunction-{\Sec}[1,]{\sec}{#1}
\let\Csc\relax
\DeclareFunction-{\Csc}[1,]{\csc}{#1}
\let\Cot\relax
\DeclareFunction-{\Cot}[1,]{\cot}{#1}
\let\ArcSin\relax
\DeclareFunction-{\ArcSin}[1,]{\arcsin}{#1}
\let\ArcCos\relax
\DeclareFunction-{\ArcCos}[1,]{\arccos}{#1}
\let\ArcTan\relax
\DeclareFunction-{\ArcTan}[1,]{\arctan}{#1}
\let\ArcSec\relax
\DeclareFunction-{\ArcSec}[1,]{\arcsec}{#1}
\let\ArcCsc\relax
\DeclareFunction-{\ArcCsc}[1,]{\arccsc}{#1}
\let\ArcCot\relax
\DeclareFunction-{\ArcCot}[1,]{\arccot}{#1}

% from M&W
\DeclareFunction+{\standardprobabilityspace}[3,1]{\Omega_{\Romannum{#1}}}{#2,#3}
\DeclareFunction+{\binomialdistribution}[3,]{\operatorname{Bin}_{#1,#2}}{#3} % binomial distribution with p=#1, n=#2
\let\complement\relax
\DeclarePostFunction-{\complement}[1]{^{c}}{#1}

% from AGLA
\newcommand{\permutations}[1]{S_{#1}} % permutations of {1,...,#1}

% from DIFF
\newcommand*{\stetigefunktionen}[1][]{C\ifstrempty{#1}{}{^{#1}}} % #1-fach stetig differenzierbare funktionen
\newcommand{\pushforward}[2]{{#2}_{\star}{#1}} % push-forward of #1 along #2    
\DeclareFunction+{\volume}[1,]{\operatorname{vol}}{#1}
\DeclareFunction+{\characteristicfunction}[2,]{\chi_{#1}}{#2}
\DeclareFunction+{\differentialforms}[2,]{\omega_{#1}}{#2} % differential forms of degree #1 of open set #2
\DeclareFunction+{\tensors}[3,]{T_{#1}^{#2}}{#3} % #1-times covariant, #2-times contravariant tensors of vector space #3 
\DeclareFunction+{\covarianttensors}[2,]{T_{#1}}{#2} % #1-times covariant tensors of vector space #2 
\DeclareFunction+{\contravarianttensors}[2,]{T^{#1}}{#2} % #1-times contravariant tensors of vector space #2
\newcommand*{\lebesgueintegrablefunctions}[1][1]{L^{#1}}
\newcommand*{\stufenfunktionen}[1][0]{\mathcal{R}_{#1}}
\newcommand{\sphere}[1]{\mathbb{S}^{#1}} % unit sphere of dimension #1
\DeclareFunction+{\ball}[2,]{B_{#1}}{#2} % ball of radius #1 around point #2
\DeclareFunction-{\diffpullback}[2,]{#1^{\star}}{#2} % pullback of #2 along #1

\DeclareFunction+{\legendrepolynomial}[2,]{P_{#1}}{#2}
\DeclareFunction+{\hermitepolynomial}[2,]{H_{#1}}{#2}
\DeclareFunction+{\laguerrepolynomial}[2,]{L_{#1}}{#2}
\DeclareFunction+{\besselfirstkind}[2,]{J_{#1}}{#2}

\DeclareFunction-{\normalenraum}[2,]{\operatorname{N}_{#1}}{#2} % \normalenraum of #2 at #1
\DeclareFunction-{\tangentialraum}[2,]{\operatorname{T}_{#1}}{#2} % \tangentialraum of #2 at #1
\DeclareFunction+{\cauchyfolgenmenge}[1,]{\mathcal{C}}{#1} % \cauchyfolgenmenge of #1 
\DeclareFunction+{\homogenreddglloesungsraum}[1,]{\mathcal{L}_{\textnormal{H}}}{#1} % space of solutions of homogenous dgl x'=#1.x, #1 matrix
\DeclareFunction+{\inhomogenreddglloesungsraum}[2,0]{\mathcal{L}_{\textnormal{I}}}{#1,#2} % space of solutions of homogenous dgl x'=#1.x+#2, #1 matrix, #2 vector 
\DeclareFunction+{\homogendglloesungsraum}[2,]{\mathcal{L}_{\textnormal{H},#1}}{#2} % space of solutions of homogenous dgl of order #3 x^{k}+#1.(k-1)x^{k-1}+...+#1.1x'+#1.0x=0, #1 array of matrices
\DeclareFunction+{\inhomogendglloesungsraum}[3,1]{\mathcal{L}_{\textnormal{I},#1}}{#2,#3} % space of solutions of homogenous dgl of order #3 x^{k}+#1.(k-1)x^{k-1}+...+#1.1x'+#1.0x=#2, #1 array of matrices, #2 vector 
\DeclareFunction+{\wronskideterminant}[1,]{W}{#1} % Wronski-Determinante an Zeitpunkt #1
\DeclareFunction-{\Ln}[1,]{\ln}{#1} % Logarithmus naturalis of #1
\DeclareFunction+{\moebiusabbildungenmenge}[1,]{\mathcal{C}}{#1} % \moebiusabbildungenmenge of #1 
\DeclareFunction-{\randpunkte}[1,]{\partial}{#1} % \randpunkte of #1 
\DeclarePostFunction-{\inneres}[1]{^{\circ}}{#1}
\newcommand{\closure}[1]{\widebar{#1}}
\newcommand*{\matrixmult}{\mathbin{.}}
\newcommand*{\laplaceoperator}{\Delta}
\newcommand*{\kroneckerdelta}[1]{\delta_{#1}} % Kronecker Delta of indices #1

% visited courses
\newcommand{\aglacourse}[1]{AGLA \Romannum{#1}}
\newcommand{\diffcourse}[1]{DIFF \Romannum{#1}}

% operators

% missing trig functions

\let\ArcCosh\relax
\DeclareFunction-{\ArcCosh}[1,]{\operatorname{arccosh}}{#1} % \ArcCosh of #1 
\let\ArcSinh\relax
\DeclareFunction-{\ArcSinh}[1,]{\operatorname{arcsinh}}{#1} % \ArcSinh of #1 
\let\ArcTanh\relax
\DeclareFunction-{\ArcTanh}[1,]{\operatorname{arctanh}}{#1} % \ArcTanh of #1 
\let\ArcSech\relax
\DeclareFunction-{\ArcSech}[1,]{\operatorname{arcsech}}{#1} % \ArcSech of #1 
\let\ArcCsch\relax
\DeclareFunction-{\ArcCsch}[1,]{\operatorname{arccsch}}{#1} % \ArcCsch of #1 
\let\ArcCoth\relax
\DeclareFunction-{\ArcCoth}[1,]{\operatorname{arccoth}}{#1} % \ArcCoth of #1 
\DeclareFunction+{\sgn}[1,]{\operatorname{sgn}}{#1} % \sgn of #1 
\DeclareFunction+{\Abb}[1,]{\operatorname{Abb}}{#1} % \Abb of #1 
\DeclareFunction-{\Ker}[1,]{\operatorname{Ker}}{#1} % \Ker of #1 
\DeclareFunction-{\Kern}[1,]{\operatorname{Kern}}{#1} % Kern of #1 
\DeclareFunction-{\Urbild}[1,]{\operatorname{Urbild}}{#1} % Bild of #1 
\DeclareFunction-{\Bild}[1,]{\operatorname{Bild}}{#1} % Bild of #1 
\DeclareMathOperator{\Id}{Id} % Identity
\DeclareFunction-{\traeger}[1,]{\operatorname{supp}}{#1} % Träger of function #1
\DeclareFunction-{\image}[1,]{\operatorname{Im}}{#1} % \image of #1 
\DeclareFunction-{\preimage}[1,]{\operatorname{Pre}}{#1} % \preimage of #1 
% \DeclareFunction-{\grad}[1,]{\operatorname{grad}}{#1} % grad of #1 
% \DeclareFunction-{\divergence}[1,]{\operatorname{div}}{#1} % divergence of vector field #1 
% \DeclareFunction-{\gradient}[1,]{\nabla}{#1} % grad of #1 
% from AGLA
\DeclareFunction-{\exterior}[2,]{\Lambda^{#1}}{#2} % Bijections of #1 
\DeclareFunction+{\bijections}[1,]{\operatorname{Bij}}{#1} % Bijections of #1 
\DeclareFunction+{\bilinearities}[3,0]{\operatorname{Bil}}{#1,#2;#3} % bilinearities of #1 x #2 into #3
% \let\endomorphisms    \relax
% \DeclareFunction+{\endomorphisms}[1,]{\operatorname{End}}{#1} % Endomorphismus of #1 
\DeclareFunction+{\automorphisms}[1,]{\operatorname{Aut}}{#1} % Automorphismus of #1 
\DeclareFunction+{\innerautomorphism}[1,]{\operatorname{Int}}{#1} % Automorphismus of #1 
\DeclareFunction+{\homomorphisms}[2,]{\operatorname{Hom}}{#1,#2} % Homomorphismen of #1 into #2
\DeclareFunction+{\fieldhomomorphisms}[3,]{\operatorname{Hom}_{#1}}{#2,#3} % Homomorphismen of #2 into #3 over field #1
\DeclareMathOperator{\Mat}{Mat} % matrices
\DeclarePairedDelimiterXPP{\matrices}[3]{\Mat}{\lparen}{\rparen}{}{#1 \times #2, #3} % #1*#2 matrices over field #3 
\newcommand{\sqmatrices}[2]{\matrices{#1}{#1}{#2}} % #1*#1-square matrices over field #2

% \DeclareFunction-{\determinant}[1,]{\det}{#1} % determinant of #1
% \DeclareFunction-{\trace}[1,]{\operatorname{tr}}{#1} % determinant of #1
\DeclareFunction+{\invertiblematrices}[2,]{\operatorname{GL}\ifstrempty{#1}{}{_{#1}}}{#2} % general linear group of #1 dimensions over field #2
\DeclareFunction+{\orthogonalmatrices}[1,]{\operatorname{O}}{#1} % orthogonal matrices of #1 
% \DeclareFunction+{\diagonalmatrix}[1,]{\operatorname{diag}}{#1} % diagonal matrix with diagonal entries #1
\DeclareFunction+{\Adj}[1,]{\operatorname{Adj}}{#1} % adjunction of #1 
\DeclareFunction+{\specialinvertiblematrices}[1,]{\operatorname{SL}}{#1} % special linear group of #1 
\DeclareFunction+{\selfadjointendomorphisms}[1,]{\operatorname{ST}}{#1} % selbstadjungierte Endomorphismen of #1 
\DeclareFunction+{\spaltenrang}[1,]{\operatorname{SR}}{#1} % Spaltenrang of #1 
\DeclareFunction+{\zeilenrang}[1,]{\operatorname{ZR}}{#1} % Zeilenrang of #1 
% \DeclareFunction+{\rank}[1,]{\operatorname{rank}}{#1} % rank of #1 
% \DeclareFunction+{\rang}[1,]{\operatorname{rang}}{#1} % rang of #1 
% \DeclareMathOperator{\Rg}{Rg} % Rang
% \DeclarePairedDelimiterXPP{\Rgof}[1]{\Rg}{\lparen}{\rparen}{}{#1} % Rg of #1 
% \DeclareMathOperator{\Rang}{Rang}
% \DeclarePairedDelimiterXPP{\Rangof}[1]{\Rang}{\lparen}{\rparen}{}{#1} % Rang of #1 
% \DeclareMathOperator{\rg}{rg}
% \DeclarePairedDelimiterXPP{\rgof}[1]{\rg}{\lparen}{\rparen}{}{#1} % rg of #1 
\DeclareFunction+{\Span}[1,]{\operatorname{Span}}{#1} % Span of #1 
\DeclareFunction+{\fieldspan}[2,]{\operatorname{Span}_{#1}}{#2} % Span of #1 over field #2 
\let\dim\relax
\DeclareFunction+{\dim }[1,]{\operatorname{dim}}{#1} % dimension of #1 
\DeclareFunction+{\fielddim}[2,]{\operatorname{dim}_{#1}}{#2} % dimension of #2 over field #1
\DeclareFunction+{\affindim}[1,]{\operatorname{dim}}{#1} % dimension of affine space #1 
\DeclareFunction+{\projectivedim}[1,]{\operatorname{dim}}{#1} % dimension of projection space #1 

\DeclareFunction+{\Spur}[1,]{\operatorname{Spur}}{#1} % Spur of #1 
\DeclarePairedDelimiterXPP{\teilverhaeltnis}[3]{\operatorname{TV}}{\lparen}{\rparen}{}{#1,#2,#3} % Teilverhältnis
\DeclarePairedDelimiterXPP{\doppelverhaeltnis}[4]{\operatorname{DV}}{\lparen}{\rparen}{}{#1,#2,#3,#4} % Doppelverhältnis
\DeclareFunction-{\characteristic}[1,]{\operatorname{char}}{#1} % characteristic of #1 
\DeclareFunction+{\fixpunkte}[1,]{\operatorname{Fix}}{#1} % Fixpunkte of #1 
\DeclareFunction+{\signature}[1,]{\operatorname{sign}}{#1} % signature of quadrik #1

% \DeclareFunction+{\exponential}[1,]{\exp}{#1} % exponential function of #1
\DeclarePairedDelimiterXPP{\polynomials}[2]{#1}{\lbrack}{\rbrack}{}{#2} % Polynomials of variables #2 over field #1 
\DeclarePairedDelimiterXPP{\noncommutativepolynomials}[2]{#1}{\langle}{\rangle}{}{#2} % Polynomials of non-commutative variables #2 over field #1 


% from DIFF
\DeclareFunction+{\diameter}[1,]{\operatorname{diam}}{#1} % Durchmesser of #1
\DeclareFunction+{\normdiameter}[2,]{\operatorname{diam}_{#1}}{#2} % Durchmesser of #2 under norm #1

% \DeclareFunction+{\distance}[1,]{\operatorname{dist}}{#1} % Distanz of #1

% from Zahlentheorie
\DeclareFunction+{\ord}[1,]{\operatorname{ord}}{#1} % order of quadrik #1
\DeclarePairedDelimiterXPP{\quadraticform}[3]{}{\langle}{\rangle}{}{#1,#2,#3} % quadratic form #1x^2+#2xy+#3y^2


\DeclareFunction+{\ggt}[1,]{\operatorname{ggT}}{#1} % größter gemeinsamer Teiler of #1 (#1 a collection)
\let\gcd\relax
\DeclarePairedDelimiterXPP{\gcd}[1]{}{\lparen}{\rparen}{}{#1}
% commands

% evaluate using vert
\newcommand{\evaluateat}[2]{\left.#1\right|_{#2}}
\newcommand{\evaluatebetween}[3]{\left.#1\right|_{#2}^{#3}}


\newif\ifincludemit
\newif\ifincludeparantheses
\newif\ifincludevert
\newif\iftextmode
\pgfkeys{/eqstep/.cd,
    m/.is if=includemit,
    p/.is if=includeparantheses,
    v/.is if=includevert}

\newcommand{\eqstep}[2][]{
    {\pgfkeys{
        /eqstep/.cd,
        m=true,
        p=true,
        v=true,
        #1
    }}
    && \ifincludevert\left|\else\fi \;\ifincludeparantheses\left(\else\fi\ifincludemit\text{mit }\else\fi #2\ifincludeparantheses\right)\else\fi\ifincludevert\right.\else\fi
}


\DeclarePostFunction-{\inverse}[1]{^{-1}}{#1} % inverse of argument
\let\inv\inverse


\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}
\DeclarePairedDelimiter{\floor}{\lfloor}{\rfloor}

\DeclarePairedDelimiter{\parens}{(}{)}
\let\p\parens % shortcut, lots of "\parens" make the .tex really cluttered

\DeclarePairedDelimiterXPP{\distance}[2]{d}{\lparen}{\rparen}{}{#1,#2}
\DeclareFunction+{\lineangle}[2,0]{\angle}{#1,#2}
\newcommand{\quotient}[2]{\ThisStyle{{\raisebox{.2em}{$\SavedStyle #1$}\left/\raisebox{-.2em}{$\SavedStyle #2$}\right.}}}
\newcommand{\quot}[2]{{
    \mathchoice
        {% \displaystyle
            \quotient{#1}{#2}%
        }
        {% \textstyle
            \quotient{#1}{#2}%
        }
        {% \scriptstyle
            #1\mathbin{/}#2%
        }
        {% \scriptscriptstyle  
            #1\mathbin{/}#2%
        }
}} % quotient set and "side fractions"      

\newcommand{\logicaland}{\mathbin{\wedge}}
\newcommand{\logicalor}{\mathbin{\vee}}



\DeclarePostFunction-{\factorial}[1]{!}{#1} % factorial of #1


% from DIFF
\DeclareFunction+{\regelfunktionen}[1,]{\operatorname{\mathcal{R}}}{#1}
\DeclareFunction+{\treppenfunktionen}[1,]{\operatorname{\mathcal{T}}}{#1}
\DeclarePostFunction-{\parendiff}[2]{^{\parens*{#2}}}{#1} % #2th derivative of #1
\DeclareFunction+{\diracmeasure}[2,]{\delta_{#1}}{#2}
\DeclareFunction+{\lebesguefunctionspace}[2,]{L^{#1}}{#2} % lebesgue (L^#1) space over a measure #2
\DeclareFunction;{\lebesguesequencespace}[2,]{\ell^{#1}}{#2} % sequence (l^#1) space over a field #2
\DeclareFunction;{\convergentsequencespace}[1,]{c}{#1} % space of convergent sequences over a field #1
\DeclareFunction;{\nullsequencespace}[1,]{c}{#1} % space of null sequences over a field #1
\DeclareFunction;{\eventuallyzerosequencespace}[1,]{c_{00}}{#1} % space of eventually zero sequences over a field #1



% from AGLA
\DeclarePairedDelimiterX{\scalarproduct}[2]{\langle}{\rangle}{#1,#2}
\DeclarePairedDelimiterX{\spatproduct}[3]{\lparen}{\rparen}{#1,#2,#3}
\newcommand{\compactification}[1]{\widebar{#1}} % Compactification of a topological space #1
\DeclarePostFunction-{\fieldwithoutzero}[1]{^{\star}}{#1} % Compactification of a topological space #1
\DeclareFunction+{\projectioncone}[1,]{\mathbb{P}}{#1} % projection of a cone #1
\DeclareFunction+{\projectionspace}[1,]{\mathbb{P}}{#1} % projection of a vector space #1
\DeclareFunction+{\projectionspaces}[1,]{\mathcal{P}}{#1} % set of projection subspaces of \projectionspace{#1} 
\DeclareFunction+{\projectionmap}[1,]{\mathbb{P}}{#1} % projection equivalent of a linear map #1
\DeclareFunction+{\projectionspaceover}[2,]{\mathbb{P}_{#1}}{#2} % projection of a vector space #2^{#1+1}, #2 a field
\DeclareFunction+{\freevectorspace}[1,]{F}{#1} % free vector space over #1
\DeclarePostFunction-{\orthogonalspace}[1]{^{\circ}}{#1} % orthogonal space (in the dual space) of a vector subspace #1
\DeclarePostFunction-{\dualspace}[1]{^{\star}}{#1} % dual space of a vector space #1
\DeclarePostFunction-{\bidualspace}[1]{^{\star\star}}{#1} % bidual space of a vector space #1
\DeclarePostFunction-{\dualvector}[1]{^{\star}}{#1} % dual vector of a vector #1
\newcommand{\equivclass}[1]{\widebar{#1}} % under an equivalence relation
\DeclarePostFunction+{\perpspace}[1]{^{\perp}}{#1} % perpendicular space to #1
\newcommand{\orth}{\ensuremath{^{\perp}}}
\DeclarePostFunction-{\transpose}[1]{^{T}}{#1} % transposed matrix of #1
\DeclarePostFunction-{\adjoint}[1]{^{*}}{#1} % adjoint matrix of #1

% basechange lower index Notation
\newcommand{\basechange}[3]{\leftidx{{_{#1}}}{{#2}}{{_{#3}}}} % Map #2 from space under base #3 to space under base #1
\newcommand{\tensorproperty}{\( \otimes \)\xspace}
\RequirePackage{xspace}
\newcommand{\tensorproduct}{\otimes}
\newcommand{\fieldtensorproduct}[1]{\otimes}

% text macros (should not be used in real texts, ok for scripts and notes)
\DeclareRobustCommand{\texistsone}{\( \exists! \)~}
\DeclareRobustCommand{\tforall}{\( \forall \)~}
\DeclareRobustCommand{\texists}{\( \exists \)~}
\DeclareRobustCommand{\tnexists}{\( \nexists \)~}
\DeclareRobustCommand{\timplies}{\( \implies \)~}
\DeclareRobustCommand{\teq}{\( = \)~}
\DeclareRobustCommand{\tsubset}{\( \subset \)~}
\DeclareRobustCommand{\tiff}{\( \iff \)~}
\DeclareRobustCommand{\tto}{\( \to \)}


\newcommand*{\naturals}{\mathbb{N}}
\newcommand*{\N}{\naturals}
\newcommand*{\integers}{\mathbb{Z}}
\newcommand*{\Z}{\integers}
\newcommand*{\rationals}{\mathbb{Q}}
\newcommand*{\Q}{\rationals}
\newcommand*{\reals}{\mathbb{R}}
\newcommand*{\R}{\reals}
\newcommand*{\complexes}{\mathbb{C}}
\newcommand*{\C}{\complexes} % doesnt work as intended...
\newcommand*{\standardfield}{\mathbb{K}} % reals or complexes
\newcommand*{\K}{\standardfield}

\newcommand{\inner}[2]{\ensuremath{\langle #1, #2\rangle}}
\newcommand{\st}{\ensuremath{\ \mathrm{s.t.}\ }}
\newcommand{\opnorm}[1]{\ensuremath{\norm{#1}_\text{op}}}
\newcommand{\hsnorm}[1]{\ensuremath{\norm{#1}_\text{HS}}}
\DeclareMathOperator{\range}{Range}
\let\rank\relax
\DeclareMathOperator{\rank}{Rank}
% \let\downchi\chi
\newcommand{\upchi}{\raisebox{2pt}{$\chi$}}
\DeclareMathOperator{\spn}{span}
\newcommand{\pd}{\partial}
\let\ol\overline
\newcommand{\dprime}{{\prime\prime}}
\DeclareMathOperator{\mat}{Mat}